<?php
/*
Plugin Name: WordPress Theme Showcase Plugin
Plugin URI: http://strangework.com/wordpress-plugins/
Description: Display themes located in wp-content/themes in a showcase gallery with theme screenshots and preview links.  Enter <strong>[showcase]</strong> in a post or page or call the php function <strong>wp_theme_preview()</strong> to display your theme screenshots and test run links.
Version: 1.4.2
Author: Brad Williams
Author URI: http://strangework.com/

Based on Preview Theme
Original Author: Ryan Boren
Original Author URI: http://boren.nu/
*/

/*

Example WordPress Theme Preview URI:
http://blog.wp/index.php?preview_theme=WordPress%20Default

*/

//  Set this to the user level required to preview themes.
$preview_theme_user_level = 0;
// Set this to the name of the GET variable you want to use.
$preview_theme_query_arg = 'preview_theme';

//hook for adding admin menus
add_action('admin_menu', 'ts_menu');

function preview_theme_stylesheet($stylesheet) {
    global $user_level, $preview_theme_user_level, $preview_theme_query_arg;

    get_currentuserinfo();

    if ($user_level  < $preview_theme_user_level) {
        return $stylesheet;
    }

    $theme = $_GET[$preview_theme_query_arg];

    if (empty($theme)) {
        return $stylesheet;
    }

    $theme = get_theme($theme);

    if (empty($theme)) {
        return $stylesheet;
    }

    return $theme['Stylesheet'];
}

function preview_theme_template($template) {
    global $user_level, $preview_theme_user_level, $preview_theme_query_arg;

    get_currentuserinfo();

    if ($user_level  < $preview_theme_user_level) {
        return $template;
    }

    $theme = $_GET[$preview_theme_query_arg];

    if (empty($theme)) {
        return $template;
    }

    $theme = get_theme($theme);

    if (empty($theme)) {
        return $template;
    }

    return $theme['Template'];
}

function wp_theme_preview($content) {

if ( !defined('WP_CONTENT_URL') )
	$pos = strpos(get_bloginfo('url'), 'wp-content');

	If ($pos === false) {
	    define( 'WP_CONTENT_URL', get_bloginfo('url') . '/');
	}Else{
		define( 'WP_CONTENT_URL', get_bloginfo('url') . 'wp-content/');
	}

	//get themes
	$themes = get_themes();

	//get options
	$options = get_option('ts_themes');
	
	if ( 1 < count($themes) ) {
	
		$theme_names = array_keys($themes);
		natcasesort($theme_names);

		foreach ($theme_names as $theme_name) {
			
			$template = $themes[$theme_name]['Template'];
			$stylesheet = $themes[$theme_name]['Stylesheet'];
			$title = $themes[$theme_name]['Title'];
			$version = $themes[$theme_name]['Version'];
			$description = $themes[$theme_name]['Description'];
			$author = $themes[$theme_name]['Author'];
			$screenshot = $themes[$theme_name]['Screenshot'];
			$stylesheet_dir = $themes[$theme_name]['Stylesheet Dir'];
			$tags = $themes[$theme_name]['Tags'];

			If (is_array($options)) {
				If (in_array($theme_name, $options)) {
					if ( $screenshot ) :
						$form = $form . '<h3><a href="' . get_bloginfo('url') . '/?preview_theme=' . $theme_name . '" target="_blank">' .  $title . '</a></h3>';
						$form = $form . '<a href="' . get_bloginfo('url') . '/?preview_theme=' . $theme_name . '" target="_blank"><img src= "' . WP_CONTENT_URL . $stylesheet_dir . '/' . $screenshot . '" alt="" /></a>';
						$form = $form . '<p><a href="' . get_bloginfo('url') . '/?preview_theme=' . $theme_name . '" target="_blank">Preview Theme</a></p>';
						$form = $form . '<p>Description: '. $description . '</p>';
						$form = $form . '<p></p>';
		
					endif;
				}
			}Else{
					$form = $form . '<h3><a href="' . get_bloginfo('url') . '/?preview_theme=' . $theme_name . '" target="_blank">' .  $title . '</a></h3>';
					$form = $form . '<a href="' . get_bloginfo('url') . '/?preview_theme=' . $theme_name . '" target="_blank"><img src= "' . WP_CONTENT_URL . $stylesheet_dir . '/' . $screenshot . '" alt="" /></a>';
					$form = $form . '<p><a href="' . get_bloginfo('url') . '/?preview_theme=' . $theme_name . '" target="_blank">Preview Theme</a></p>';
					$form = $form . '<p>Description: '. $description . '</p>';
					$form = $form . '<p></p>';
			}

		}

	}
	
	If ($content) {
		return str_replace('[showcase]', $form, $content);
	}Else{
		echo $form;
	}

}

function ts_menu() {
  add_options_page('Theme Showcase Options', 'Theme Showcase', 8, __FILE__, 'ts_options');
}

//Function to save the plugin settings
function update_options()
{
	check_admin_referer('ts_check');
	$themes = $_POST['theme'];
	update_option('ts_themes', $themes);
}

function ts_options() {

	if ( isset($_POST['update_ts_options'])
		&& $_POST['update_ts_options']
		)
	{
		update_options();

		echo "<div class=\"updated\">\n"
			. "<p>"
				. "<strong>"
				. __('Settings saved.')
				. "</strong>"
			. "</p>\n"
			. "</div>\n";
	}
	

?>
<H1>Theme Showcase Options</H1>
<?php
	$pos = strpos(get_bloginfo('url'), 'wp-content');

	If ($pos === false) {
	    define( 'WP_CONTENT_URL', get_bloginfo('url') . '/');
	}Else{
		define( 'WP_CONTENT_URL', get_bloginfo('url') . 'wp-content/');
	}
	
	//load themes
	$themes = get_themes();
	
	//load options
	$options = get_option('ts_themes');

	if ( 1 < count($themes) ) {

		$theme_names = array_keys($themes);
		natcasesort($theme_names);

		echo '<div><strong>Themes to Display</strong></div>';
		echo '<form method="post">';
		if ( function_exists('wp_nonce_field') ) wp_nonce_field('ts_check');
		echo '<input type="hidden" name="update_ts_options" value="1">';
		echo '<div>';
		foreach ($theme_names as $theme_name) {

		If (is_array($options)) {
			If (in_array($theme_name, $options)) {
				$checked = "CHECKED";	
			}Else{
				$checked = "";	
			}
		}Else{
			$checked = "";	
		}
			
			echo '<input type="checkbox" name="theme[]" value="'.$theme_name.'" '.$checked.'> ' .$theme_name.'<BR>';

		}
		echo '<p class="submit">'
		. '<input type="submit"'
			. ' value="' . attribute_escape(__('Save Changes')) . '"'
			. ' /></p>';
		echo '* if no themes are selected ALL themes will be displayed';
		echo '</div>';
		echo '</form>';
		

	}

	echo '<p>For support please visit our <a href="http://webdevstudios.com/support/wordpress-plugins/" target="_blank">WordPress Plugins Support page</a> | Version 1.4.2 by <a href="http://webdevstudios.com/" title="WordPress Development and Design" target="_blank">WebDevStudios.com</a> | <a href="http://twitter.com/webdevstudios" target="_blank">WDS on Twitter</a></p>';
	echo '</div>';
}

add_filter('stylesheet', 'preview_theme_stylesheet');
add_filter('template', 'preview_theme_template');
add_filter('the_content', 'wp_theme_preview');
?>